// Copyright (C) 2022 WYATT GROUP
// Please see the AUTHORS file for details.
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program. If not, see <https://www.gnu.org/licenses/>.

import 'package:flutter/material.dart';
import 'package:wyatt_ui_layout/src/presentation/layouts/layout.dart';
import 'package:wyatt_ui_layout/wyatt_ui_layout.dart';

/// {@template content_layout}
/// An abstract class that provides a base for creating custom content layout
/// widgets.
/// {@endtemplate}
abstract class ContentLayout extends Layout {
  /// {@macro content_layout}
  const ContentLayout({super.key});

  factory ContentLayout.withGrid({
    required List<Widget> children,
    double verticalGap = 30,
    double horizontalGap = 30,
  }) =>
      GridLayout(
        verticalGap: verticalGap,
        horizontalGap: horizontalGap,
        children: children,
      );
}
